/**
 * 
 */
package org.processmining.models.operationalsupport;

import java.util.ArrayList;

/**
 * 
 * @author Maja Pesic
 * 
 */
public class ProviderResponse {
	private final ArrayList<Analysis> analysis;
	private final ArrayList<Prediction> predictions;
	private final ArrayList<Recommendation> recommendations;

	private String providerName;

	public ProviderResponse(String providerName) {
		super();
		this.providerName = providerName;
		analysis = new ArrayList<Analysis>();
		predictions = new ArrayList<Prediction>();
		recommendations = new ArrayList<Recommendation>();
	}

	public void addPrediction(Prediction prediction) {
		predictions.add(prediction);
	}

	public void addRecommendation(Recommendation recommendation) {
		recommendations.add(recommendation);
	}

	public void addAnalysis(Analysis analysis) {
		this.analysis.add(analysis);
	}

	public Iterable<Analysis> getAnalysis() {
		return analysis;
	}

	public Iterable<Prediction> getPrediction() {
		return predictions;
	}

	public Iterable<Recommendation> getRecommendation() {
		return recommendations;
	}

	public void setProviderName(String providerName) {
		this.providerName = providerName;
	}

	public String getProviderName() {
		return providerName;
	}

	public int getAnalysisCount() {
		return analysis.size();
	}

	public int getPredictionCount() {
		return predictions.size();
	}

	public int getRecommendationCount() {
		return recommendations.size();
	}

	/*
	 * public void print() { System.out.println("   provider " +
	 * this.providerName + " analysisNr=" + analysis.size() + " predictionNr=" +
	 * predictions.size() + " recommendationNr=" + recommendations.size()); for
	 * (Analysis a : analysis) { a.print(); } for (Prediction p : predictions) {
	 * p.print(); } for (Recommendation r : recommendations) { r.print(); } }
	 */

}
