package org.processmining.models.operationalsupport;

import java.util.Collection;
import java.util.HashSet;

import org.deckfour.xes.extension.std.XLifecycleExtension.StandardModel;

public class WorkItem {
	private String task;
	private StandardModel transition;
	private final HashSet<String> authorizedResources;

	public WorkItem(String task, StandardModel transition) {
		super();
		this.task = task;
		this.transition = transition;
		authorizedResources = new HashSet<String>();
	}

	public WorkItem(String task, StandardModel transition, HashSet<String> authorizedResources) {
		super();
		this.task = task;
		this.transition = transition;
		this.authorizedResources = authorizedResources;
	}

	public int hashCode() {
		int hash = 7;
		hash = 31 * hash + (null == task ? 0 : task.hashCode());
		hash = 31 * hash + (null == transition ? 0 : transition.hashCode());
		return hash;
	}

	public void setTask(String task) {
		this.task = task;
	}

	public String getTask() {
		return task;
	}

	public void setTransition(StandardModel transition) {
		this.transition = transition;
	}

	public StandardModel getTransition() {
		return transition;
	}

	public boolean addAuthorizedResource(String res) {
		return authorizedResources.add(res);
	}

	public Collection<String> getAuthorizedResources() {
		return new HashSet<String>(authorizedResources);
	}

	// TODO remove
	public String toTaskString() {
		return task;
	}
}
