package org.processmining.models.operationalsupport.gui;

import java.util.ArrayList;
import java.util.Iterator;

import org.processmining.models.operationalsupport.Attributes;
import org.processmining.models.operationalsupport.Recommendation;
import org.processmining.models.operationalsupport.RecommendationItem;

/**
 * 
 * @author mschonen; joyce nakatumba; mpesic
 * 
 */
public class HTMLAttributes {
	private final String html;

	public HTMLAttributes(String title, Attributes a) {
		super();
		html = getAttributes(title, a);
	}

	public HTMLAttributes(String title, Recommendation recommendation) {
		super();
		html = getRecommendationTable(title, recommendation);
	}

	public String getHtml() {
		return html;
	}

	private String getRecommendationTable(String title, Recommendation recommendation) {
		String html = "<html> ";

		ArrayList<RecommendationItem> recItems = recommendation.getRecItems();

		html += "<table border=\"1\" width=\"10\">";
		html += "<tr bgcolor=\"#C0C0C0\"><td colspan=" + recItems.get(0).getAttributes().size() + "<center><b>" + title
				+ "</b></center></td></tr>";
		html += "<tr bgcolor=\"#C0C0C0\">";

		//	create header
		Attributes attrs = recItems.get(0).getAttributes();
		for (String name : attrs.keySet()) {
			html += " <td >" + name + "</td>";
		}
		html += " </tr> ";

		// create table contents
		Iterator<RecommendationItem> iter = recItems.iterator();
		while (iter.hasNext()) {
			RecommendationItem item = iter.next();
			Attributes a = item.getAttributes();

			html += " <tr> ";
			for (String name : a.keySet()) {
				html += " <td >" + a.get(name).toString() + "</td>";
			}
			html += "</tr>";

		}

		html += "</tr>";
		html += "</table>";
		html += "</html>";
		return html;
	}

	private String getAttributes(String title, Attributes a) {
		String html = "<html> ";
		html += "<table border=\"1\" width=\"10\">";
		html += "<tr bgcolor=\"#C0C0C0\"><td colspan=" + 2 + "<center><b>" + title + "</b></center></td></tr>";

		// Table Header
		html += " <tr bgcolor=\"#C0C0C0\"> ";
		html += " <td>" + "Description" + "</td>";
		html += " <td>" + "Value" + "</td>";
		html += " </tr> ";

		// Table Header
		for (String name : a.keySet()) {
			html += " <tr> ";
			html += " <td bgcolor=\"#C0C0C0\">" + name + "</td>";
			html += " <td >" + a.get(name).toString() + "</td>";
			html += "</tr>";
		}

		html += "</tr>";
		html += "</table>";
		html += "</html>";
		return html;
	}

}
