package org.processmining.models.operationalsupport.gui;

import java.util.Vector;

import org.processmining.models.operationalsupport.Analysis;
import org.processmining.models.operationalsupport.Recommendation;

class NodeWithAttributes extends Vector<HTMLAttributes> implements OSNode {
	private static final long serialVersionUID = 1L;
	private final Analysis analysis;
	private Recommendation recommendation;

	public NodeWithAttributes(Analysis a) {
		super();
		analysis = a;
	}

	public NodeWithAttributes(Analysis a, Recommendation recommendation) {
		super();
		analysis = a;
		this.recommendation = recommendation;
	}

	public Analysis getAnalysis() {
		return analysis;
	}

	public Recommendation getRecommendation() {
		return recommendation;
	}

	public synchronized String toAnalysisString() {
		return analysis.getText();
	}

	public synchronized String toRecommendationString() {
		return recommendation.getText();
	}

}
