/**
 * 
 */
package org.processmining.models.operationalsupport.net.provider.impl;

import org.processmining.framework.util.socket.ServiceEnvironment;
import org.processmining.models.operationalsupport.ProviderResponse;
import org.processmining.models.operationalsupport.Request;
import org.processmining.models.operationalsupport.net.provider.Provider;
import org.processmining.models.operationalsupport.net.service.OSService;

/**
 * This abstract class provides a clean high-level interface for providers of
 * operational support. A new OS provider is aded by extending this class.
 * 
 * @author Maja Pesic
 * 
 */
public abstract class AbstractProvider implements Provider {

	private final OSService owner; // the service owner.

	public AbstractProvider(OSService owner) {
		super();
		this.owner = owner;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.processmining.plugins.operationalsupport.net.provider.Provider#getOwner
	 * ()
	 */
	public OSService getOwner() {
		return owner;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @seeorg.processmining.plugins.operationalsupport.net.provider.Provider#
	 * populateResponse
	 * (org.processmining.plugins.operationalsupport.net.ServiceEnvironment,
	 * org.processmining.plugins.operationalsupport.Request,
	 * org.processmining.plugins.operationalsupport.ProviderResponse)
	 */
	public abstract void populateResponse(ServiceEnvironment environment, Request request, ProviderResponse response);
}
