package org.processmining.models.operationalsupport.xml;

import org.deckfour.xes.xstream.XAttributeConverter;
import org.deckfour.xes.xstream.XAttributeMapConverter;
import org.deckfour.xes.xstream.XConverter;
import org.deckfour.xes.xstream.XEventConverter;
import org.deckfour.xes.xstream.XExtensionConverter;
import org.deckfour.xes.xstream.XTraceConverter;
import org.processmining.models.operationalsupport.Request;
import org.processmining.models.operationalsupport.Response;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.DomDriver;

public class OSXMLConverter {

	protected XStream xStream;

	public OSXMLConverter() {
		super();
		xStream = new XStream(new DomDriver()); // create XStream

		// register default converters
		registerConverter(new XAttributeConverter());
		registerConverter(new XAttributeMapConverter());
		registerConverter(new XEventConverter());
		registerConverter(new XExtensionConverter());
		registerConverter(new XTraceConverter());

		registerConverter(new XOSRequestConverter()); // register request converter

		registerConverter(new XOSResponseConverter()); // register Response converter
		registerConverter(new XOSProviderResponseConverter()); // register ProviderResponse converter
	}

	private void registerConverter(XConverter converter) {
		xStream.registerConverter(converter);
		converter.registerAliases(xStream);
	}

	public Request requestFromXML(String xml) {
		return (Request) xStream.fromXML(xml);
	}

	public String requestToXML(Request request) {
		return xStream.toXML(request);
	}

	public Response responseFromXML(String xml) {
		return (Response) xStream.fromXML(xml);
	}

	public String responseToXML(Response request) {
		return xStream.toXML(request);
	}
}
